unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Clipbrd, ComCtrls, shellapi, IdHTTP, IdSMTP, IdMessage;

type
  TformMenuPrincipal = class(TForm)
    dlGuardar: TSaveDialog;
    temporizador: TTimer;
    bIniciarCamara: TButton;
    bDetener: TButton;
    bCerrar: TButton;
    pImagen: TPanel;
    bGuardarImagen: TButton;
    bGuardarVideo: TButton;
    StaticText1: TStaticText;
    GroupBox1: TGroupBox;
    tbVelocidad: TTrackBar;
    Label3: TLabel;
    Label2: TLabel;
    tbSensibilidad: TTrackBar;
    txtPScroll: TEdit;
    GroupBox2: TGroupBox;
    txtError: TEdit;
    Label1: TLabel;
    LWEB: TLabel;
    bSelFichero: TButton;
    txtUbicacionImg: TEdit;
    Label4: TLabel;
    bIniciarDeteccion: TButton;
    procedure FormCreate(Sender: TObject);
    procedure bGuardarImagenClick(Sender: TObject);
    procedure bIniciarCamaraClick(Sender: TObject);
    procedure bGuardarVideoClick(Sender: TObject);
    procedure bDetenerClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bCerrarClick(Sender: TObject);
    procedure temporizadorTimer(Sender: TObject);
    procedure tbVelocidadChange(Sender: TObject);
    procedure tbSensibilidadChange(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
    procedure bSelFicheroClick(Sender: TObject);
    procedure bIniciarDeteccionClick(Sender: TObject);
  private
    { Private declarations }
    idResultado : THandle;
    capturandoAVI : Boolean;
    imagenActual, imagenAnterior : TBitmap;
    Contador : Integer;
    Capturar : Boolean;

  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}
var
  compEnvioEmail : TIdSMTP;

  const WM_CAP_START = WM_USER;
  const WM_CAP_STOP = WM_CAP_START + 68;
  const WM_CAP_DRIVER_CONNECT = WM_CAP_START + 10;
  const WM_CAP_DRIVER_DISCONNECT = WM_CAP_START + 11;
  const WM_CAP_SAVEDIB = WM_CAP_START + 25;
  const WM_CAP_GRAB_FRAME = WM_CAP_START + 60;
  const WM_CAP_SEQUENCE = WM_CAP_START + 62;
  const WM_CAP_FILE_SET_CAPTURE_FILEA = WM_CAP_START + 20;
  const WM_CAP_EDIT_COPY = WM_CAP_START+ 30;
  const WM_CAP_SET_PREVIEW = WM_CAP_START+ 50;
  const WM_CAP_SET_PREVIEWRATE = WM_CAP_START+ 52;

  function capCreateCaptureWindowA(lpszWindowName : PCHAR;
      dwStyle : longint; x : integer; y : integer; nWidth : integer;
      nHeight : integer; ParentWin : HWND; nId : integer): HWND; stdcall external 'AVICAP32.DLL';






//Funcin para conectar con el servidor de email
function ConectarServidorEmail (servidor : string; usuario : string; puerto : integer) : boolean;
begin
  compEnvioEmail := TIdSMTP.Create(nil);
  compEnvioEmail.host := servidor;
  compEnvioEmail.userid := usuario;
  compEnvioEmail.Port := puerto;
  try
    compEnvioEmail.connect;
  except
    compEnvioEmail.Free;
    ConectarServidorEmail := false;
  end;
end;

//enviar email
function enviarEmail (servidor : string; usuario : string; contrasena : string;
    puerto : integer; asunto : string; mensaje : TStringList; conAutenticacion : boolean;
    emisor : string; nombreEmisor : string; destinatario : string; cc : string) : boolean;
var
  compMensaje : TIdMessage;
  textoTemp : string;
  tipoAutenticacion : TAuthenticationType;
  envioCorrecto : boolean;
begin
  if conAutenticacion then
  begin
    compEnvioEmail.AuthenticationType := atLogin;
    compEnvioEmail.UserId := usuario;
    compEnvioEmail.Password := contrasena;
  end
  else
    compEnvioEmail.AuthenticationType := atNone;
  compMensaje := TIdMessage.Create (nil);
  compMensaje.From.Address := emisor;
  compMensaje.From.Name := nombreEmisor;
  compMensaje.Recipients.Add.Address := destinatario;
  compMensaje.CCList.Add.Address := cc;
  compMensaje.Body.AddStrings (mensaje);
  compMensaje.Subject := asunto;
  compMensaje.ReplyTo.Add.Address := emisor;
  envioCorrecto := true;
  try
    compEnvioEmail.Send(compMensaje);
  except
    envioCorrecto := false;
  end;
  compMensaje.Free;
  enviarEmail := envioCorrecto;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  capturandoAVI := false;
  idResultado := 0;
  dlGuardar.Options := [ofHideReadOnly, ofNoChangeDir, ofPathMustExist];
  imagenActual := TBitMap.create;
  imagenAnterior := TBitMap.create;
  Capturar := False;
end;

procedure TformMenuPrincipal.bGuardarImagenClick(Sender: TObject);
begin
  if idResultado <> 0 then
  begin
    dlGuardar.DefaultExt := 'bmp';
    dlGuardar.Filter := 'Fichero Bitmap (*.bmp)|*.bmp';
    if dlGuardar.Execute then
      SendMessage(idResultado, WM_CAP_SAVEDIB, 0,
          longint(pchar(dlGuardar.FileName)));
  end;
end;

procedure TformMenuPrincipal.bIniciarCamaraClick(Sender: TObject);
begin
  idResultado := capCreateCaptureWindowA('My Own Capture Window',
      WS_CHILD or WS_VISIBLE,  pImagen.Left, pImagen.Top, pImagen.Width,
      pImagen.Height, formMenuPrincipal.Handle, 0);
  if idResultado <> 0 then
  begin
    try
      SendMessage(idResultado, WM_CAP_DRIVER_CONNECT, 0, 0);
      SendMessage(idResultado, WM_CAP_SET_PREVIEWRATE, 40, 0);
      SendMessage(idResultado, WM_CAP_SET_PREVIEW, 1, 0);
      bIniciarCamara.Enabled := false;
      bDetener.Enabled := true;
      bGuardarImagen.Enabled := true;
      bGuardarVideo.Enabled := true;
      temporizador.Enabled := True;
      bIniciarDeteccion.Enabled := true;
    except
      temporizador.Enabled := false;
      bIniciarDeteccion.Enabled := false;
      raise;
    end;
  end
  else
  begin
    temporizador.Enabled := false;
    MessageDlg ('Error al conectar al driver de la cmara.',
        mtError, [mbok], 0);
    bDetener.Enabled := false;
    bIniciarCamara.Enabled := True;
    bGuardarVideo.Enabled := false;
    bIniciarDeteccion.Enabled := false;
  end;
end;



procedure TformMenuPrincipal.bGuardarVideoClick(Sender: TObject);
begin
  if idResultado <> 0 then
  begin
    dlGuardar.DefaultExt := 'avi';
    dlGuardar.Filter := 'Fichero AVI (*.avi)|*.avi';
    if dlGuardar.Execute then
    begin
      capturandoAVI := true;
      SendMessage(idResultado, WM_CAP_FILE_SET_CAPTURE_FILEA, 0,
          Longint(pchar(dlGuardar.FileName)));
      SendMessage(idResultado, WM_CAP_SEQUENCE, 0, 0);
    end;
  end;
end;

procedure TformMenuPrincipal.bDetenerClick(Sender: TObject);
begin
  if idResultado <> 0 then
  begin
    SendMessage(idResultado, WM_CAP_DRIVER_DISCONNECT, 0, 0);
    idResultado := 0;
    bDetener.Enabled := false;
    bGuardarImagen.Enabled := false;
    bGuardarVideo.Enabled := false;
    bIniciarDeteccion.Enabled := false;
    bIniciarCamara.Enabled := true;
  end;
  temporizador.Enabled := False;
  Capturar := false;
end;

procedure TformMenuPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  bDetenerClick(Self);
end;

procedure TformMenuPrincipal.bCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.temporizadorTimer(Sender: TObject);
var
  error : int64;
  i, j : integer;
  hayMovimiento : boolean;
begin
  if idResultado <> 0 then
  begin
    try
      //capturamos la imagen actual
      SendMessage(idResultado, WM_CAP_EDIT_COPY, 0, 0);
      imagenActual.Assign(imagenAnterior);
      //la imagen anterior est guardada en el portapapeles, la obtenemos
      imagenAnterior.LoadFromClipBoardFormat(cf_BitMap,
          ClipBoard.GetAsHandle(cf_Bitmap), 0);
      error := 0;
      //recorremos todos los pxeles de la imagen actual
      for i := 0 to imagenActual.Width do
      begin
        for j:= 0 to imagenActual.Height do
        begin
          //comparamos el pixel de la imagen actual con el correspondiente
          //a la imagen anterior
          error := error + abs(imagenActual.Canvas.Pixels[i, j] -
              imagenAnterior.Canvas.Pixels[i, j]);
        end;
      end;
      //mostramos el porcentaje de error
      txtError.Text := FloatToStr(trunc(error / 20000000)/100);
    except
      bDetenerClick(Self);
      raise;
    end;
    hayMovimiento := tbSensibilidad.Position < StrToFloat(txtError.Text);
    if (hayMovimiento and Capturar) then
    begin
      imagenAnterior.SaveToFile(ExtractFilePath(txtUbicacionImg.Text) +
          IntToStr(Contador) + ExtractFileName(txtUbicacionImg.Text));
      imagenActual.SaveToFile(ExtractFilePath(txtUbicacionImg.Text) +
          IntToStr(Contador + 1) + ExtractFileName(txtUbicacionImg.Text));
      Contador := Contador + 2;
    end;
    if hayMovimiento then
      txtError.Color := clRed
    else
      txtError.Color := clWhite;
  end
  else
  begin
    bDetenerClick(Self);
    MessageDlg('Debe inicar la cmara para capturar el movimiento.', mtWarning, [mbok], 0);
  end;
end;

procedure TformMenuPrincipal.tbVelocidadChange(Sender: TObject);
begin
  temporizador.Interval := tbVelocidad.Position;
end;

procedure TformMenuPrincipal.tbSensibilidadChange(Sender: TObject);
begin
  txtPScroll.Left := tbSensibilidad.Left + tbSensibilidad.Position + 15;
  txtPScroll.Text := IntToStr(tbSensibilidad.Position);
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.bSelFicheroClick(Sender: TObject);
begin
  dlGuardar.DefaultExt := 'bmp';
  dlGuardar.Filter := 'Fichero Bitmap (*.bmp)|*.bmp';
  if dlGuardar.Execute then
    txtUbicacionImg.Text := dlGuardar.FileName;
end;

procedure TformMenuPrincipal.bIniciarDeteccionClick(Sender: TObject);
begin
  if not DirectoryExists(ExtractFilePath (txtUbicacionImg.Text)) then
  begin
    Capturar := false;
    MessageDlg('Debe indicar una carpeta existente y un nombre ' +
        'de fichero para la captura del movimiento.', mtWarning, [mbok], 0);
  end
  else
  begin
    Contador := 0;
    Capturar := true;
    if not temporizador.Enabled then
      temporizador.Enabled := true;
  end;
end;

end.
